
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    function inputcheck(DF: Boolean): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses mp_real, mp_types, mp_base, Velthuis.BigDecimals;

var
  DRD : integer;  // L
  dsr : string;   // ΂̒lstring

const
  DEG = '180';      // 180

// ΂̌vZ KEXWh̃ASY
// pcs ΂̐x
// np  true [v@\
function pi_big(pcs: integer; np: boolean): Bigdecimal;
var
  a, b, t, x, an, two, one, four, EPSILON : BigDecimal;
  n, dpcs, pcsBack : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcs + 10;                                   // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := BigDecimal.One;
  two := BigDecimal.Two;
  EPSILON := one / BigDecimal.IntPower(two, pcs shl 1);   // l
  one := one.RoundToPrecision(dpcs);                  // one̗Ldpcsɐݒ
  two := two.RoundToPrecision(dpcs);                  // two̗Ldpcsɐݒ
  four := two + two;
  a := one;
  b := one / BigDecimal.Sqrt(two);
  t := one / four;                                    // Zx
  x := '1';
  n := 0;
  repeat
    an := (a + b) / two;                              // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +   ۂ
    b := BigDecimal.Sqrt(b);
    t := t - x * (an - a) * (an - a);
    t := t.RoundToPrecision(dpcs);                    // pcs +   ۂ
    x := x + x;
    a := an;
    inc(n);
  until (BigDecimal.abs(a - b) < EPSILON) or (n > 100);   // n>100̓fobOp
  a := a + b;
  result := (a * a) / (four * t);                     // qƕ̗L
//  result := result.RoundToPrecision(pcs);             // w̐xɊۂ

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA

  if np then
    Form1.Memo1.Lines.Append('΂̌vZ KEXWh Big n = ' + intTostr(n));
end;

// ̓`FbN
// L̓ǂݍ݃Zbg       DRD
// ΂̒lmp_floatBigDecimalStringϊ dsrB
// DF double tO
function TForm1.inputcheck(DF: Boolean): boolean;
var
  x : double;
  c : integer;
  paif : mp_float;
  paib : BigDecimal;
begin
  result := false;
  val(labelededit1.Text, x, c);
  if c <> 0 then begin
    memo1.Text := 'x̒lɊԈႢ܂B';
    exit;
  end;
  if abs(x) > 90 then begin
    memo1.Text := 'x̒l90ȉɂĉB';
    exit;
  end;
  val(labelededit2.Text, DRD, c);
  if c <> 0 then begin
    memo1.Text := 'x̒lɊԈႢ܂B';
    exit;
  end;
  if (DRD < 30) or (DRD > 1000) then begin
    memo1.Text := 'x̒l30ȏ@ 1000ɂĉB';
    exit;
  end;
  if not DF then
    if checkbox1.Checked = False then begin             // ΂̒lvZI
      paib := pi_big(DRD, true);                        // L (DRD + 10)
      dsr := paib.ToPlainString;
    end
    else begin
      mpf_set_default_decprec(DRD + 10);                // L DRD + 10ɐݒ
      mpf_init(paif);
      mpf_set_pi(paif);                                 // ΂̒l
      dsr := string(mpf_adecimal_alt(paif, DRD + 10));  // L DRD + 10 Stringϊ
      mpf_clear(paif);
      Form1.Memo1.Lines.Append('΂̒l@{');
    end;
  result := true;
end;

// sin(x)vZ double
// }N[WJ
// delphiɂ͕Wsin(x)gݍ܂Ă܂QlpłB
function sindouble(xi: double): double;
var
  x, v, d, sq, u : double;
  k : integer;
begin
  x := abs(xi);
  d := x;
  sq := x * x;
  u := d;
  k := 0;
  repeat
    k := k + 2;
    v := u;
    d := -d * sq / (k * (k + 1));
    u := v + d;
  until (v = u) or (k > 100);
  if xi < 0 then v := -v;
  result := v;

  Form1.memo1.Lines.Append('Double sin ϊ[v n=' + intTostr(k));        // Loop\
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  x : double;
begin
  if not inputcheck(True) then exit;;
  x := strTofloat(labelededit1.Text);
  x := x / 180 * pi;
  x := sindouble(x);
  memo1.Lines.Append(floatTostr(x));
  memo1.Lines.Append('');
end;

// sin(x)vZ {
// }N[WJ
// mp_arith ɂ́Asin֐肱̃vO͎QlpłB
procedure sinmpf(var xi, v : mp_float);
var
  tmp0, tmp1 : mp_float;
  x, K: mp_float;
  d, sq, u, one, two, vd : mp_float;
  c : integer;
begin
  mpf_init2(tmp0, tmp1);
  mpf_init3(x, K, d);
  mpf_init5(sq, u, one, two, vd);

  mpf_abs(xi, x);                                   // Βl
  mpf_set1(one);                                    // 1
  mpf_add(one, one, two);                           // 2
  mpf_copy(x, d);                                   // x = d
  mpf_sqr(x, sq);                                   // sq = x * x
  mpf_copy(x, u);                                   // x = u
  mpf_set0(k);                                      // k = 0
  c := 0;
  repeat                                            // repeat
    mpf_add(k, two, k);                             // k = k + 2
    mpf_copy(u, v);                                 // u = v
    mpf_add(k, one, tmp0);                          // tmp0 = k + 1
    mpf_mul(tmp0, k, tmp1);                         // tmp1 = k(k + 1)
    mpf_div(sq, tmp1, tmp0);                        // tmp0 = sq / k(k + 1)
    mpf_chs(d, d);                                  // d = -d
    mpf_mul(d, tmp0, d);                            // d = d * tmp0   d = -d * sq / k(k + 1)
    mpf_add(v, d, u);                               // u := v + d
    inc(c);                                         // c = c + 1
  until mpf_is_eq(v, u) or (c > 500);               // until (v = u) or (c > 200)
  if not mp_real.s_mpf_is_ge0(xi) then mpf_chs(v, v);                     // ݒ

  Form1.memo1.Lines.Append('Mp_float sin ϊ[v n=' + intTostr(c));        // Loop\

  mpf_clear2(tmp0, tmp1);
  mpf_clear3(x, K, d);
  mpf_clear5(sq, u, one, two, vd);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  x, v, pai : mp_float;
begin
  if not inputcheck(False) then exit;;

  mpf_set_default_decprec(DRD + 10);                // xDRD + 10ɐݒ
  mpf_init3(x, v, pai);

  if checkbox1.Checked = False then
    mpf_read_decimal(pai, pansichar(ansistring(dsr))) //  BigDecimalvZl
  else
    mpf_set_pi(pai);                                  // 
  mpf_read_decimal(x, pansichar(ansistring(Form1.LabeledEdit1.Text)));   // 
  mpf_div_int(x, 180, x);                           // Radϊ  x = x / 180
  mpf_mul(x, pai, x);                               // x = x * pi
  sinmpf(x, v);                                     // sin(x)

  memo1.Lines.Append(string(mpf_adecimal_alt(v, DRD)));     // DRD\
  memo1.Lines.Append('');

  mpf_clear3(x, v, pai);
end;

// sin(x)vZ BigDecimal
// }N[WJ
// BigDecimaĺA
// ZALDefault傫āAq̗L̗L傫ꍇ
// Zɐ悾ĕqɏ鎞͂̏_ȉARoundToŏ邩A
// Default̗L傫Kv܂A͗]T悤łAӂKvłB
// ̌L傫ꍇALȊOɂ"0"͂܂B
// Zł̗Lۂ߂͏Zł܂B
function sinBig(xi : BigDecimal): BigDecimal;
var
  x, v, d, sq, u, k : BigDecimal;
  c: integer;
begin
  x := BigDecimal.Abs(xi);                    // Βl
  d := x;
  sq := x * x;                                // sq͏_ȉ (DRD + 10) * 2 
  u := d;
  k := 0;
  c := 0;
  repeat
    k := k + 2;
    v := u;
    d := -d * sq;                             // _ȉ(DRD + 10)~2 
    d := d.RoundToPrecision(DRD + 10);        // LDRD + 10Ɋۂ߂ȂƎ̏Zs͏_ȉ
    d := d / (k * (k + 1));                   // ZŗLDRD + 10 ZDefaultl
    u := v + d;
    u := u.RoundToPrecision(DRD + 10);        // LDRD + 10Ɋۂ߂ȂƎ̏Zs͏_ȉ
    inc(c);
  until (v = u) or (c > 500);
  if xi < 0 then v := -v;                     // ݒ
  result := v;

  Form1.memo1.Lines.Append('BigDecimal sin ϊ[v n=' + intTostr(c));        // Loop\
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
  x , v : BigDecimal;
  pai, d180 : BigDecimal;
begin
  if not inputcheck(False) then exit;;
  BigDecimal.DefaultPrecision := DRD + 10;         // Zł̃ftHg̗L L𒴂ꍇLȊO"0"
  BigDecimal.DefaultRoundingMode := rmNearestDown;  // ftHg̊ۂߎw
  if checkbox1.Checked = False then           // ΂̒lݒ
    pai := pi_big(DRD + 10, False)            // ΂̌vZ KEXWh̃ASY
  else
    pai := dsr;                               // ΂̒lݒ pai := dsr {->big
  x := labelededit1.Text;                     // px 덷hstringڕϊ
  x := x * pai;                               // radɕϊ x͏_ȉ100 + x _ȉ͒l
  x := x.RoundTo(-DRD - 2);                   // x_ȉDRD + 2Ɋۂ߂ȂƎ̏ZoȂ܂
  d180 := DEG;
  x := x / d180;                              // x͗LDRD + 10 ZDefaultl x < pi / 2
  v := sinBig(x);                             // sin(x)
  v := v.RoundTo(-DRD + 1);                   // _ȉDRD-1\DRDŊۂ |V| <=1
  v := BigDecimal(v).RemoveTrailingZeros(0);  // ̃[
  memo1.Lines.Append(v.ToPlainString);        // l\
  memo1.Lines.Append('');
end;

// {_̗pɂsin(x)̌vZ
// mp_floatBigDecimal̒lStringŕϊ
function sinmpg(xi : BigDecimal): BigDecimal;
var
  x, v : mp_float;
begin
  mpf_set_default_decprec(DRD + 10);               // mp_float xDRD + 10ɐݒ
  mpf_init2(x, v);

  mpf_read_decimal(x, pansichar(ansistring(xi.ToPlainString))); // BigDecimal -> mp_float
  mpf_sin(x, v);                                                // {sin(x)
  result := string(mpf_adecimal_alt(v, DRD));                   // mp_float -> BigDecimal

  Form1.memo1.Lines.Append('{->BIG sin ϊ[v');       // Loop\

  mpf_clear2(x, v);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  x , v : BigDecimal;
  pai, d180 : BigDecimal;
begin
  if not inputcheck(False) then exit;;
  BigDecimal.DefaultPrecision := DRD + 10;   // Zł̃ftHg̗L L𒴂ꍇ͐擪̌
  BigDecimal.DefaultRoundingMode := rmNearesteven;  // ftHg̊ۂߎw
  pai := dsr;                                 // ΂̒lݒ
  x := labelededit1.Text;                     // px 덷hstringڕϊ
  x := x * pai;                               // radɕϊ  _ȉ͒l
  x := x.RoundToPrecision(DRD + 10);          // xLDRD + 10Ɋۂ߂ȂƎ̏ZoȂ܂
  d180 := DEG;
  d180 := d180.RoundToPrecision(DRD + 10);
  x := x / d180;                              // x͗LDRD + 10 ZDefaultl x < pi / 2
  v := sinmpg(x);                             // sin(x)
  v := v.RoundTo(-DRD + 1);                   // _ȉDRDŊۂ
  v := BigDecimal(v).RemoveTrailingZeros(0);  // ̃[
  memo1.Lines.Append(v.ToPlainString);        // l\
  memo1.Lines.Append('');
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  memo1.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.Width := 820;                     // s100\ɐݒ
  memo1.Font.Size := 11;                  // s100\ɃtHgTCYݒ
end;

end.
